/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

public class Haltepunkt extends SpurElement {
	public void initRoute (SpurElement l, SpurElement r, boolean lr, Signal signal, Fahrstrasse fahr_str) {
		super.initRoute (l, r, 0);
		vlnr = lr;
		sig = signal;
		fs = fahr_str;
	}
	
	public int signalStellung (boolean richtung) {
		if (richtung) {
			if (rechts == null) return 0;
			return rechts.signalStellung(true);
		} else {
			if (links == null) return 0;
			return links.signalStellung(false);
		}
	}
	
	public int signalDistanz (boolean richtung, int pos) {
		if (richtung == vlnr) {
			if (sig.stellung == 0) return 0;
			if (!fs.eingestellt) return 0;
		}

		return super.signalDistanz (richtung, pos);
	}
	
	boolean vlnr;
	Signal sig;
	Fahrstrasse fs;
}
