/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.Canvas;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;

abstract class Hebel extends Canvas implements MouseListener {
//	public static void LoadImages () {
	public Hebel (int nr, String ns) {
		setSize (60, 420);
		addMouseListener (this);
		id = nr;
		
		nummernschild = Tools.loadImage (ns);
	}
	
	public void mouseClicked (MouseEvent e) {
		// Die grsse Betrgt 420 x 60
		int x;
		int y;
		
		x = e.getX();
		y = e.getY();
		
		if (hat_fb_hebel && !position) {
			if (x < 25 && y > 70 && y < 110) {
				if (y < 90) {
					if (fb_hebel_pos == true) {
						fb_hebel_pos = false;
						fahrbegriff_sound.play();
					}
				} else {
					if (fb_hebel_pos == false) {
						fb_hebel_pos = true;
						fahrbegriff_sound.play();
					}
				}
			}
		}
		if (y > 210) positionMinus();
		else positionPlus();
//		Stellwerk.hf.repaintHebel(id);
		repaint();
	}
	
	public abstract void positionPlus ();
	public abstract void positionMinus ();
	
	public boolean istPlus () {
		return (!position);
	}
	
	public boolean istMinus () {
		return (position);
	}
	
	public void paint (Graphics g) {
		g.clearRect (0, 0, 60, 420);
		if (position) {
			g.drawImage (hebel_minus, 0, 0, null);
			g.drawImage (nummernschild, 25, 310, null);
			if (hat_fb_hebel) {
				if (fb_hebel_pos) g.drawImage(fbh_unten, 15, 310, null);
				else g.drawImage(fbh_oben, 15, 310, null);
			}
		} else {
			g.drawImage (hebel_plus, 0, 0, null);
			g.drawImage (nummernschild, 25, 70, null);
			if (hat_fb_hebel) {
				if (fb_hebel_pos) g.drawImage(fbh_unten, 15, 70, null);
				else g.drawImage(fbh_oben, 15, 70, null);
			}
		}
	}
	
	public void mousePressed (MouseEvent e) { }
	public void mouseReleased (MouseEvent e) { }
	public void mouseEntered (MouseEvent e) { }
	public void mouseExited (MouseEvent e) { }

	protected BufferedImage hebel_plus;
	protected BufferedImage hebel_minus;
	
	protected BufferedImage nummernschild;
	
	protected boolean position;
	protected boolean hat_fb_hebel;
	protected boolean fb_hebel_pos;
	
	static BufferedImage wh_plus;
	static BufferedImage wh_minus;
	static BufferedImage sh_plus;
	static BufferedImage sh_minus;
	static BufferedImage fbh_oben;
	static BufferedImage fbh_unten;
	
	
	static AudioClip weichenhebel_sound;
	static AudioClip signalhebel_sound;
	static AudioClip fahrbegriff_sound;
	
	static {
		sh_plus = Tools.loadImage("signalhebel_plus");
		sh_minus = Tools.loadImage("signalhebel_minus");
		wh_plus = Tools.loadImage("weichenhebel_plus");
		wh_minus = Tools.loadImage("weichenhebel_minus");
		fbh_oben = Tools.loadImage("fb_hebel_oben");
		fbh_unten = Tools.loadImage("fb_hebel_unten");
		
		signalhebel_sound = Applet.newAudioClip(ClassLoader.getSystemResource("sounds/SH.wav"));
		weichenhebel_sound = Applet.newAudioClip(ClassLoader.getSystemResource("sounds/WH.wav"));
		fahrbegriff_sound = Applet.newAudioClip(ClassLoader.getSystemResource("sounds/FB.wav"));
	}
	
	int id;
}
