/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

class Weichenhebel extends Hebel {
	public Weichenhebel (int nr, String filename_schild, Hebelsperre wei_k) {
		super(nr, filename_schild);
		hebel_plus = wh_plus;
		hebel_minus = wh_minus;
		hat_fb_hebel = false;
		wk = (Weichenhebelsperre) wei_k;
	}
	
	public void setWeiche(Weiche w) {
		weiche = w;
	}
	
	public void positionPlus () {
		if ((gesperrt != 0) || !position) return;
		if (weiche.belegt) return;
		wk.umlegen();
		try { Thread.sleep(200); } catch (InterruptedException e) {}
		weichenhebel_sound.play();
		position = false;
		weiche.stellen(false);
	}
	
	public void positionMinus () {
		if ((gesperrt != 0) || position) return;
		if (weiche.belegt) return;
		wk.umlegen();
		try { Thread.sleep(200); } catch (InterruptedException e) {}
		weichenhebel_sound.play();
		position = true;
		weiche.stellen(true);
	}
	
	public boolean weicheVerschliessen (boolean pos, boolean ausfuehren) {
		if (position && !pos) return false;
		if (!position && pos) return false;
		if (!ausfuehren) return true;
		gesperrt++;
		return true;
	}
	
	public void weicheFreigeben () {
		if (gesperrt <= 0) System.out.println ("Weichenfreigabe: Weiche nicht gesperrt");
		gesperrt--;
	}
	
	int gesperrt;
	
	Weichenhebelsperre wk;
	Weiche weiche;
	
	static final long serialVersionUID = 6869475659824523597L;
}
