/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

public class Zug implements Runnable {
	public Zug (SpurElement gl, boolean r, int l, int p, int g) {
		front = new Position();
		schluss = new Position();
		front.akt_gl = gl;
		front.akt_gl.belegen(richtung);
		if (r) {
			front.pos = front.akt_gl.laenge - p;
		} else {
			front.pos = p;
		}
		richtung = r;
		schluss.akt_gl = front.akt_gl;
		schluss.pos = front.pos;
		laenge = l;
		
		richtung = !richtung;
		geschw = laenge;
		fahreSchritt(schluss, true);
		richtung = !richtung;
		geschw = g;
	}
	
	public void run() {
		int neu_geschw;
		while (true) {
			try {
				Thread.sleep(360);
			} catch (InterruptedException e) {
				System.out.println ("Zug interrupted");
			}
			
			switch (front.akt_gl.signalStellung(richtung)) {
			case 1:
				neu_geschw = 10;
				break;
			case 2:
				neu_geschw = 4;
				break;
			default:
				neu_geschw = 0;
			}
			
			ziel_distanz = front.akt_gl.signalDistanz(richtung, front.pos);

			if (ziel_distanz > 150 && neu_geschw < 4) {
				ziel_geschw = 4;
			} else {
				ziel_geschw = neu_geschw;
			}
			
//			System.out.println ("Speed = " + geschw + ", ziel = " + ziel_geschw + ", ziel_distanz = " + ziel_distanz);
			
			// Beschleunigung a = 0.05 m / 0.36s = 0.3m/s
			if (ziel_geschw != geschw) {
				cnt--;
				if (cnt < 0) cnt = -1;
				if (ziel_geschw < geschw) {
					if (ziel_distanz < 750) {
						if (cnt <= 0) {
							if (ziel_distanz < 150 || geschw > 4) {
								geschw--;
								cnt = 12;
							}
						}
					}
					
					if (ziel_distanz < 5) {
						// Kleiner Hack...
						geschw = ziel_geschw;
					}
				}
				if (ziel_geschw > geschw) {
					if (cnt <= 0) {
						geschw++;
						cnt = 12;
					}
				}
			}
			
			fahreSchritt(front, true);
			fahreSchritt(schluss, false);
			
			if (zug_weg) {
//				System.out.println ("Zug ist weg...");
				return;
			}
		}
	}
		
	void fahreSchritt(Position p, boolean bel) {
		if (richtung) p.pos += geschw;
		else p.pos -= geschw;
		while (p.pos > p.akt_gl.laenge) {
			p.pos -= p.akt_gl.laenge;
			if (p.akt_gl.rechts == null) {
				if (!bel) {
					p.akt_gl.freigeben(richtung);
					zug_weg = true;
					return;
				} else return;
			}
			if (!bel) p.akt_gl.freigeben(richtung);
			p.akt_gl = p.akt_gl.rechts;
			if (bel) p.akt_gl.belegen(richtung);
		}
		while (p.pos < 0) {
			if (p.akt_gl.links == null) {
				if (!bel) {
					p.akt_gl.freigeben(richtung);
					zug_weg = true;
					return;
				} else return;
			}
			if (!bel) p.akt_gl.freigeben(richtung);
			p.akt_gl = p.akt_gl.links;
			p.pos += p.akt_gl.laenge;
			if (bel) p.akt_gl.belegen(richtung);
		}
	}
	
	int geschw;
	int ziel_geschw;
	int ziel_distanz;
	int cnt;

	boolean richtung;
	int laenge;
	
	class Position {
		int pos;
		SpurElement akt_gl;
	}
	
	Position front;
	Position schluss;
	
	public boolean zug_weg;
}
